我将如何验证程序是否存在,以返回错误并退出或继续执行脚本的方式?
看起来应该很容易,但它一直困扰着我。
POSIX 兼容:
command -v <the_command>
示例使用:
if ! command -v <the_command> &> /dev/null then echo "<the_command> could not be found" exit fi
对于 Bash 特定环境:
hash <the_command> # For regular commands. Or... type <the_command> # To check built-ins and keywords
避免which。它不仅是您启动的一个外部进程,只需要做很少的事情(hash意味着type像command.系统到系统。
which
hash
type
command
为什么关心?
if which foo``foo``hash
所以,不要使用which. 而是使用其中之一:
$ command -v foo >/dev/null 2>&1 || { echo >&2 "I require foo but it's not installed. Aborting."; exit 1; } $ type foo >/dev/null 2>&1 || { echo >&2 "I require foo but it's not installed. Aborting."; exit 1; } $ hash foo 2>/dev/null || { echo >&2 "I require foo but it's not installed. Aborting."; exit 1; }
(小旁注:有些人会建议2>&-相同2>/dev/null但更短 -这是不正确的。 2>&-关闭 FD 2 会在程序尝试写入 stderr 时导致错误,这与成功写入并丢弃输出非常不同(而且很危险!))
2>&-
2>/dev/null
如果您的哈希爆炸是/bin/sh那么您应该关心 POSIX 所说的内容。typeandhash的退出代码没有被 POSIX 很好地定义,并且hash当命令不存在时可以看到成功退出(还没有看到这个type)。 command的退出状态由 POSIX 明确定义,因此使用起来可能是最安全的。
/bin/sh
但是,如果您的脚本使用bash,POSIX 规则就不再重要了,并且两者都可以type完全hash安全地使用。type现在有一个-P只搜索PATH并且hash具有命令的位置将被散列的副作用(以便下次使用它时更快地查找),这通常是一件好事,因为您可能会检查它的存在以便实际使用它.
bash
-P
PATH
gdate作为一个简单的例子,这是一个如果存在则运行的函数,否则date:
gdate
date
gnudate() { if hash gdate 2>/dev/null; then gdate "$@" else date "$@" fi }
您可以使用scripts-common来满足您的需求。
要检查是否安装了某些东西,您可以执行以下操作:
checkBin <the_command> || errorMessage "This tool requires <the_command>. Install it please, and then run this tool again."